/* KALKULACKA PRE CELE A REALNE CISLA - vstup pre YACC	*/
/*   so zabudovanym chybovym zotavenim	 			*/

%union {
	int ihod;
	double rhod;
	struct { int jeint;double hod;} vhod;
};


%start kalkul
%token <ihod>	ICISLO
%token <rhod>	RCISLO
%token		PLUS MINUS KRAT DELENE 
%token		CR LZAT PZAT 
	/* priorita a asociativita operatorov */
%left PLUS MINUS
%left KRAT DELENE
%left UMINUS		/* pre unarne minus */

%type <vhod> vyraz

%{

#include "lexyy.cpp"	/* vlozenie lex. analyzatora */

void yyerror(char *);
int yyparse(void),main(void);
%}

%%
kalkul	  :
	  | kalkul vypocet
	  | kalkul error CR
	  ;
vypocet	  : vyraz CR
		{
		 if($1.jeint)printf("%d\n",(int)$1.hod);
		 else printf("%f\n",$1.hod);
		}
	  ;
vyraz	  : vyraz PLUS vyraz
		{
		 if($1.jeint && $3.jeint) $$.jeint = 1;
		 else $$.jeint = 0;
		 $$.hod = $1.hod + $3.hod;
		}
	  | vyraz MINUS vyraz
		{
		 if($1.jeint && $3.jeint) $$.jeint = 1;
		 else $$.jeint = 0;
		 $$.hod = $1.hod - $3.hod;
		}
	  | vyraz KRAT vyraz
		{
		 if($1.jeint && $3.jeint) $$.jeint = 1;
		 else $$.jeint = 0;
		 $$.hod = $1.hod * $3.hod;
		}
	  | vyraz DELENE vyraz
		{
		 if($1.jeint && $3.jeint) $$.jeint = 1;
		 else $$.jeint = 0;
		 $$.hod = $1.hod / $3.hod;
		}
	  | MINUS vyraz  %prec UMINUS
		{
		 $$.jeint = $2.jeint;
		 $$.hod = - $2.hod;
		}
	  | LZAT vyraz PZAT
		{ $$ = $2;}
	  | ICISLO
		{
		 $$.jeint = 1;
		 $$.hod = (double)$1;
		}
	  | RCISLO
		{
		 $$.jeint = 0;
		 $$.hod = $1;
		}
	  ;
%%
void yyerror(char *s){ printf("%s\n",s); }

int main(){ 
	printf("KALKULACKA ZAPNUTA\n");
	(void)yyparse();
	printf("KALKULACKA VYPNUTA\n");
	return(0);
}

