%{
	/* atributy vyrazu */
typedef struct {char *sig;char*kod;} ATRV;
%}

	/* definicia prenasanych hodnot */
%union  {
	char* meno;
	char* txt;
	char* sig;
	unsigned int mod;
	int ihod;
	double dhod;
	char* kod;
	ATRV vhod;
	}
	/* definicia term. symbolov a hodnoty nimi prenasane */
%token		BOOLEAN  DOUBLE  INT  LONG  VOID
%token  		CLASS  EXTENDS  CONSTRUCTOR IMPLEMENTS IMPORT 
%token		PUBLIC PRIVATE PROTECTED
%token		STATIC FINAL ABSTRACT NATIVE
%token		NEW THIS SUPER RETURN IF ELSE WHILE
%token 		PRINTLN
%token <meno> 	ID
%token <txt>	STR_LITERAL
%token <ihod>   TRIEDA INT_LITERAL
%token <dhod>   DBL_LITERAL
%token		NULL_LITERAL
%token		TRUE_LITERAL
%token		FALSE_LITERAL
%token  	LZZAT  PZZAT  LOZAT  POZAT  LHZAT  PHZAT
%token  	CIARKA  BCIARKA  BODKA  ROVNE
	/* priradenie priorit a asociativnosti operatorom */
%left		AND OR
%binary		LT LE GT GE EQ NE
%left		PLUS MINUS
%left		KRAT DEL

	/* priradenie prenasanych hodnot neterm. symbolom */
%type <ihod>	NadTrieda
%type <sig>	NepParametre  Parametre  TypVoid  TypDat
%type <mod>	ModTriedy  ModClena  Mod1  Mod2
%type <vhod>	Primarny Vyraz 
%type <kod>     VyrazPr Prikaz Prikazy


%{
typedef unsigned int uint;
typedef	struct { uint pristup;
		char *meno;
		char *signatura;
		} dclen;
typedef	struct { uint pristup;
		char *meno;
		char *signaturaP;char *signaturaR;
		int velkostLP;
		char *kod;
		} met;

struct {
	char *menoTr; char *javaTr;char *sigTr;
	char *menoNadTr; int ixntr;
	uint pristup;
	int pocDatClenov;
	dclen* DatCleny;
	int pocMetod;
	met* Metody;
} triedy[20];
int ix_tr=0;
int ix_m=0;

#define MOD_PUBLIC    0x0001
#define MOD_PRIVATE   0x0002
#define MOD_PROTECTED 0x0004
#define MOD_STATIC    0x0008
#define MOD_FINAL     0x0010
#define MOD_NATIVE    0x0100
#define MOD_ABSTRACT  0x0400

#include <alloc.h>
#include <stdio.h>
#include <string.h>

FILE *vyst;
int ii,i1,i2;
char sigpom[80];
			/* prototypy */
int yyparse(void), yylex(void);
void ulozImp(char *,char *);
void ulozTr(char *,int,uint);
void ulozDC(char *,char *,uint);
void ulozMet(char *,char *,char *,uint);
int testEM(char *m,int ix);
int testEDC(char *m,int ix);
void yyerror(char*),xxerror(char*,char*);
void vypisTriedy(int);
int najdiDC(char *m,int ix,int *ixx);
int najdiM(char *m,char *sg,int ix,int *ixx);
int najdiT(char *sg);
#include "lexyy.cpp"
%}

%%
Subor		: Importy Trieda
		| Subor  Trieda
		;
Importy		: /* e */
		| Importy  Import
		;
Import		: IMPORT  ID  NATIVE  STR_LITERAL
			{ ulozImp($2,$4);}
		;
Trieda		: CLASS  ModTriedy ID  NadTrieda  ImpRozhrania
			{ ulozTr($3,$4,$2);}
		  LZZAT  Cleny  PZZAT
		;
ModTriedy	:          {$$=0;}
		| PUBLIC   {$$=MOD_PUBLIC;}
		| ABSTRACT {$$=MOD_ABSTRACT;}
		| FINAL	   {$$=MOD_FINAL;}
		;
NadTrieda	: /* e */
			{ $$=0;}
		| EXTENDS  TRIEDA
			{ $$=$2;}
		;
ImpRozhrania	: /* e */
		| ImpRozhrania IMPLEMENTS TRIEDA
		;
Cleny		: /* e */
		| Cleny  DatovyClen
		| Cleny  Metoda
		| Cleny  error
		;
DatovyClen	: ModClena TypDat  ID  BCIARKA
			{ ulozDC($3,$2,$1);}
		;
ModClena	: Mod1 Mod2 	{$$=$1|$2;}
		;
Mod1		: 		{$$=0;}
		| PUBLIC	{$$=MOD_PUBLIC;}
		| PROTECTED	{$$=MOD_PROTECTED;}
		| PRIVATE	{$$=MOD_PRIVATE;}
		;
Mod2		: 		{$$=0;}
		| STATIC	{$$=MOD_STATIC;}
		| ABSTRACT	{$$=MOD_ABSTRACT;}
		| FINAL		{$$=MOD_FINAL;}
		| STATIC FINAL  {$$=MOD_STATIC|MOD_FINAL;}
		;
Metoda		: ModClena TypDat  ID  {;} LOZAT  NepParametre  POZAT
			{ ulozMet($3,$6,$2,$1);}
			TeloMet
		| ModClena TypVoid  ID  {;} LOZAT  NepParametre  POZAT
			{ ulozMet($3,$6,$2,$1);}
			TeloMet
		| CONSTRUCTOR {;} LOZAT NepParametre POZAT
			{ ulozMet("<init>",$4,"V",MOD_PUBLIC);}
			TeloMet
		;
NepParametre	: /* e */
			{ $$=(char*)malloc(3);strcpy($$,"()");}
		| Parametre
			{ $$=strcat($1,")");}
		;
Parametre	: TypDat  ID
			{ $$=(char*)malloc(256);strcpy($$,"(");strcat($$,$1);}
		| Parametre  CIARKA  TypDat  ID
			{ $$=strcat($1,$3);}
		;
TypVoid		: VOID
			{$$="V";}
		;
TypDat		: INT
			{$$="I";}
		| DOUBLE
			{$$="D";}
		| BOOLEAN
			{$$="Z";}
		| TRIEDA
			{ $$=triedy[$1].sigTr;}
		| TRIEDA LHZAT PHZAT
			{ $$=sigpom;sprintf(sigpom,"[%s",triedy[$1].sigTr);}
		;
TeloMet		: BCIARKA
		| LZZAT  Prikazy  PZZAT   {triedy[ix_tr-1].Metody[ix_m].kod=$2;}
		;
Prikazy 	: /* e */ {$$=(char*)malloc(6148);$$[0]=0;}
		| Prikazy Prikaz
			{if($2!=NULL){$$=strcat($1,$2);free($2);}
			 else $$=$1;
			}
		| Prikazy error 
			{ $$=$1; }
		;
Prikaz		: TypDat ZozIdent BCIARKA
			{$$=NULL;}
		| VyrazPr BCIARKA
			{$$=$1;}
		| RETURN BCIARKA
			{$$=(char*)malloc(10);sprintf($$,"\treturn\n");}
		| BCIARKA
			{$$=NULL;}
		| RETURN Vyraz BCIARKA
			{$$=NULL;}
		| WHILE LOZAT Vyraz POZAT Prikaz
			{$$=NULL;}
		| IF LOZAT Vyraz POZAT Prikaz ELSE Prikaz
			{$$=NULL;}
		| IF LOZAT Vyraz POZAT Prikaz
			{$$=NULL;}
		| LZZAT Prikazy PZZAT
			{$$=$2;}
		;
ZozIdent	: ID {;}
		| ZozIdent CIARKA ID {;}
		;
Vyraz		: Primarny		{$$=$1;}
		| Vyraz PLUS Vyraz	{$$.kod=NULL;}
		| Vyraz MINUS Vyraz 	{$$.kod=NULL;}
		| Vyraz KRAT Vyraz	{$$.kod=NULL;}
		| Vyraz DEL Vyraz 	{$$.kod=NULL;}
		| Vyraz LT Vyraz	{$$.kod=NULL;}
		| Vyraz LE Vyraz	{$$.kod=NULL;}
		| Vyraz GT Vyraz	{$$.kod=NULL;}
		| Vyraz GE Vyraz	{$$.kod=NULL;}
		| Vyraz EQ Vyraz	{$$.kod=NULL;}
		| Vyraz NE Vyraz	{$$.kod=NULL;}
		| Vyraz OR Vyraz	{$$.kod=NULL;}
		| Vyraz AND Vyraz	{$$.kod=NULL;}
		;
VyrazPr 	:  ID ROVNE Vyraz		{$$=NULL;}
		|  DCPrirad			{$$=NULL;}
		|  MetVolanie			{$$=NULL;}
		|  LOZAT VOID POZAT MetVolanie	{$$=NULL;}
		|  PRINTLN LOZAT INT_LITERAL CIARKA INT_LITERAL POZAT Vyraz
			{
			 $$=(char*)malloc(200+strlen($7.kod));
			 if(strcmp($7.sig,"Ljava/lang/String;")==0){ 
				sprintf($$,"\taload\t1\n%s"
					"\tsipush\t%d\n"
					"\tsipush\t%d\n"
					"\tinvokevirtual\tjava/awt/Graphics\tdrawString (Ljava/lang/String;II)V\n",
					$7.kod,$3,$5);
			 } else { 
				sprintf($$,"\taload\t1\n%s"
					"\tinvokestatic\tjava/lang/String\tvalueOf (%s)Ljava/lang/String;\n"
					"\tsipush\t%d\n"
					"\tsipush\t%d\n"
					"\tinvokevirtual\tjava/awt/Graphics\tdrawString (Ljava/lang/String;II)V\n",
					$7.kod,$7.sig,$3,$5);
			 }
			 free($7.kod);
			}
		;
Primarny	: ID			{ $$.sig="E";$$.kod=NULL;}
		| THIS			{ $$.sig="E";$$.kod=NULL;}
		| NovyObjekt		{ $$.sig="E";$$.kod=NULL;}
		| MetVolanie		{ $$.sig="E";$$.kod=NULL;}
		| DCPristup		{ $$.sig="E";$$.kod=NULL;}
		| NULL_LITERAL
			{
			 $$.sig="Ljava/lang/Object;";$$.kod=(char*)malloc(20);
			  sprintf($$.kod,"\taconst_null\n");
			 }
		| INT_LITERAL
			{ $$.sig="I";$$.kod=(char*)malloc(20);
			  sprintf($$.kod,"\tsipush\t%d\n",$1);
			}
		| DBL_LITERAL
			{ $$.sig="D";$$.kod=(char*)malloc(80);
			  sprintf($$.kod,"\tldc2_w\t%lf\n",$1);
			}
		| STR_LITERAL
			{ $$.sig=triedy[1].sigTr;$$.kod=(char*)malloc(10+strlen($1));
			  sprintf($$.kod,"\tldc\t\"%s\"\n",$1);
			}
		| TRUE_LITERAL
			{
			 $$.sig="Z";$$.kod=(char*)malloc(12);
			  sprintf($$.kod,"\ticonst_1\n");
			 }
		| FALSE_LITERAL
			{
			 $$.sig="Z";$$.kod=(char*)malloc(12);
			  sprintf($$.kod,"\ticonst_0\n");
			 }
		| LOZAT  Vyraz  POZAT
			{ $$=$2;}
		| TRIEDA LOZAT Vyraz POZAT
			{
			 $$.sig=triedy[$1].sigTr;
			 $$.kod=$3.kod; 
			}
		| INT LOZAT Vyraz POZAT
			{ 
			  $$.sig="I";
			  if($3.sig[0]=='I'){$$.kod=$3.kod;}
			  else if($3.sig[0]=='D'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\td2i\n",$3.kod);free($3.kod);
				}
			  else if($3.sig[0]=='J'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\tl2i\n",$3.kod);free($3.kod);
				}
			  else { xxerror("Nemozno konvertovat na INT: ",$3.sig);
				$$.kod=$3.kod;
				}
			}
		| DOUBLE LOZAT Vyraz POZAT
			{
			 $$.sig="D";
			 $$.kod=(char*)malloc(30);sprintf($$.kod,"DOPLNIT\n");
			}
		| LONG LOZAT Vyraz POZAT
			{
			 $$.sig="J";
			 $$.kod=(char*)malloc(30);sprintf($$.kod,"DOPLNIT\n");
			}
		;		
NovyObjekt 	: NEW  TRIEDA  LOZAT  NepArgumenty  POZAT
		;
MetVolanie	: TRIEDA BODKA ID LOZAT NepArgumenty POZAT
		| SUPER LOZAT NepArgumenty POZAT
		| Primarny BODKA ID  LOZAT  NepArgumenty POZAT
		;
DCPristup	: TRIEDA BODKA ID
		| Primarny BODKA ID
		;
DCPrirad	: TRIEDA BODKA ID  ROVNE Vyraz
		| Primarny BODKA ID  ROVNE Vyraz
		;
NepArgumenty    : /* e */
		| Argumenty
		;
Argumenty       : Vyraz
		| Argumenty  CIARKA  Vyraz
		;
%%

static int pocetChyb=0;
void yyerror(char *s){
fprintf(stdout,"CHYBA: %s [%s:%d]\n",s,yytext,riadok);
pocetChyb++;
}

void xxerror(char *s1,char *s2){
fprintf(stdout,"CHYBA: %s %s [%d]\n",s1,s2,riadok);
pocetChyb++;
}

static char src[20];

int main(int ac,char *av[]){
extern FILE *yyin;
int i;
if(ac>1){
	yyin=fopen(av[1],"r");strcpy(src,av[1]);
	if(yyin==NULL){yyin=stdin;strcpy(src,"stdin");}
	}
ulozImp("Object","java/lang/Object");
ulozImp("String","java/lang/String");
ulozImp("System","java/lang/System");
(void)yyparse();
fprintf(stderr,"POCET CHYB: %d\n",pocetChyb);
for(i=0;i<ix_tr;i++)vypisTriedy(i);
getchar();
return(0);
}

char* ulozStr(char *s){
return strdup(s);
}

void ulozImp(char *meno,char *jmeno){
FILE *fi;char t[80],t1[80],t2[80],dt[10];int i,pdc,pm;uint pr;
fi=fopen("java.api","r");
if(fi==NULL){xxerror("Nemozno najst archiv","java.api");return;}
fscanf(fi,"%s",t);
while(strcmp(t,".end")!=0){
	if(strcmp(t,".class")!=0 && strcmp(t,".interface")!=0){fscanf(fi,"%s",t);continue;}
	fscanf(fi,"%x %s",&pr,t);if(strcmp(t,jmeno)!=0){fscanf(fi,"%s",t);continue;}
	triedy[ix_tr].pristup=pr|MOD_NATIVE;
	triedy[ix_tr].menoTr=meno;triedy[ix_tr].javaTr=jmeno;
	triedy[ix_tr].sigTr=(char*)malloc(strlen(jmeno)+3);
	sprintf(triedy[ix_tr].sigTr,"L%s;",jmeno);
	triedy[ix_tr].menoNadTr=NULL;triedy[ix_tr].ixntr= -1;
	fscanf(fi,"%s",t);
	if(strcmp(t,".super")==0){ fscanf(fi,"%s",t);
		for(i=0;i<ix_tr;i++)
			if(strcmp(triedy[i].menoTr,t)==0||strcmp(triedy[i].javaTr,t)==0){
				triedy[ix_tr].menoNadTr=triedy[i].menoTr;triedy[ix_tr].ixntr=i;
				}
		if(triedy[ix_tr].ixntr<0){xxerror("Nemozno najst nadtriedu:",t);}
		}
	fscanf(fi,"%d",&pdc);triedy[ix_tr].pocDatClenov=pdc;
	if(pdc>0)triedy[ix_tr].DatCleny=(dclen*)calloc(pdc,sizeof(dclen));
	for(i=0;i<pdc;i++){ fscanf(fi,"%s %x %s %s\n",dt,&pr,t1,t2);
			triedy[ix_tr].DatCleny[i].meno=ulozStr(t1);
			triedy[ix_tr].DatCleny[i].signatura=ulozStr(t2);
			triedy[ix_tr].DatCleny[i].pristup=pr;
			}
	fscanf(fi,"%d",&pm);triedy[ix_tr].pocMetod=pm;
	if(pm>0)triedy[ix_tr].Metody=(met*)calloc(pm,sizeof(met));
	for(i=0;i<pm;i++){ fscanf(fi,"%s %x %s %s %s\n",dt,&pr,t,t1,t2);
			triedy[ix_tr].Metody[i].pristup=pr;
			triedy[ix_tr].Metody[i].meno=ulozStr(t);
			triedy[ix_tr].Metody[i].signaturaP=ulozStr(t1);
			triedy[ix_tr].Metody[i].signaturaR=ulozStr(t2);
			}
	ix_tr++;
	fclose(fi);return;
	}
fclose(fi);
xxerror("Nemozno najst JAVA triedu:",jmeno);
}

void ulozTr(char *meno,int ixNT,uint mod){
int i,j,k;
	triedy[ix_tr].menoTr=meno;triedy[ix_tr].javaTr=meno;
	triedy[ix_tr].sigTr=(char*)malloc(strlen(meno)+3);
	sprintf(triedy[ix_tr].sigTr,"L%s;",meno);
	triedy[ix_tr].ixntr= ixNT;
	if(triedy[ixNT].pristup&MOD_FINAL)xxerror("Nemozno dedit z FINAL triedy",triedy[ixNT].menoTr);
	triedy[ix_tr].menoNadTr=triedy[ixNT].menoTr;
	triedy[ix_tr].pristup=mod;
	triedy[ix_tr].pocDatClenov=0;
	triedy[ix_tr].DatCleny=(dclen*)calloc(20,sizeof(dclen));
	triedy[ix_tr].pocMetod=0;
	triedy[ix_tr].Metody=(met*)calloc(20,sizeof(met));
	ix_tr++;
}

int testEDC(char *m,int ix){
int i;
for(i=0;i<triedy[ix].pocDatClenov;i++)
	if(strcmp(m,triedy[ix].DatCleny[i].meno)==0)return 1;
if(triedy[ix].ixntr<0)return 0;
return testEDC(m,triedy[ix].ixntr);
}

int testEM(char *m,int ix){
int i;
for(i=0;i<triedy[ix].pocMetod;i++)
	if(strcmp(m,triedy[ix].Metody[i].meno)==0)return 1;
if(triedy[ix].ixntr<0)return 0;
return testEM(m,triedy[ix].ixntr);
}

void ulozDC(char *meno,char *sig,uint mod){
int i,poc,ixt;
	ixt=ix_tr-1;
	poc=triedy[ixt].pocDatClenov;
	for(i=0;i<poc;i++)
		if(strcmp(triedy[ixt].DatCleny[i].meno,meno)==0){
			xxerror("Viacnasobna deklaracia datoveho clena:",meno);
			return;
			}
	if(testEM(meno,ixt)){xxerror("Existuje (zdedena) metoda:",meno);return;}
	triedy[ixt].DatCleny[poc].meno=meno;
	triedy[ixt].DatCleny[poc].pristup=mod;
	if(mod&MOD_ABSTRACT)xxerror("Datovy clen nemoze byt abstraktny:",meno);
	triedy[ixt].DatCleny[poc].signatura=sig;
	triedy[ixt].pocDatClenov++;
}


void ulozMet(char *meno,char *sigP,char *sigR,uint mod){
int i,ixt;
char *sig;
	ixt=ix_tr-1;
	ix_m=triedy[ixt].pocMetod;
	for(i=0;i<ix_m;i++)
		if(strcmp(triedy[ixt].Metody[i].meno,meno)==0 &&
			 strcmp(triedy[ixt].Metody[i].signaturaP,sigP)==0){
				xxerror("Viacnasobna deklaracia metody:",meno);
				return;
				}
	if(testEDC(meno,ix_tr)){xxerror("Existuje (zdedeny) datovy clen:",meno);return;}
	triedy[ixt].Metody[ix_m].meno=meno;
	triedy[ixt].Metody[ix_m].pristup=mod;
	triedy[ixt].Metody[ix_m].signaturaP=sigP;
	triedy[ixt].Metody[ix_m].signaturaR=sigR;
	triedy[ixt].Metody[ix_m].kod=NULL;
	triedy[ixt].pocMetod++;
}

int najdiDC(char *m,int ix,int *ixx){
int i;
if(ixx!=NULL)*ixx=ix;
for(i=0;i<triedy[ix].pocDatClenov;i++)
	if(strcmp(m,triedy[ix].DatCleny[i].meno)==0){return i;}
if(ixx==NULL || triedy[ix].ixntr<0){xxerror("Neexistujuci dat.clen:",m);return 0;}
return najdiDC(m,triedy[ix].ixntr,ixx);
}

int najdiM(char *m,char *sg,int ix,int *ixx){
int i;
if(ixx!=NULL)*ixx=ix;
for(i=0;i<triedy[ix].pocMetod;i++)
	if(strcmp(m,triedy[ix].Metody[i].meno)==0&&strcmp(sg,triedy[ix].Metody[i].signaturaP)==0){return i;}
if(ixx==NULL || triedy[ix].ixntr<0){xxerror("Neexistujuca metoda:",m);return 0;}
return najdiM(m,sg,triedy[ix].ixntr,ixx);
}

int najdiT(char *sg){
int i;
for(i=0;i<ix_tr;i++)if(strcmp(sg,triedy[i].sigTr)==0)return i;
xxerror("Neexistujuca trieda:",sg);
return 0;
}

void ImplicitnyKonstruktor(int ix,FILE *vyst){
int i,ixn;
for(i=0;i<triedy[ix].pocMetod;i++)
	if(strcmp("<init>",triedy[ix].Metody[i].meno)==0&&strcmp("()",triedy[ix].Metody[i].signaturaP)==0)return;
//autoamticke doplnenie
ixn=triedy[ix].ixntr;
fprintf(vyst,"\n.method public  <init> ()V\n");
fprintf(vyst,"\t.stack 50\n");
fprintf(vyst,"\t.locals 3\n");
fprintf(vyst,"\taload_0\n");
fprintf(vyst,"\tinvokespecial\t%s <init> ()V\n",triedy[ixn].javaTr);
fprintf(vyst,"\treturn\n");
fprintf(vyst,".endm\n");
}

char *vratMod(uint mod){
static char textmod[80];
textmod[0]='\0';
if(mod&MOD_PUBLIC)strcat(textmod,"public ");
if(mod&MOD_PROTECTED)strcat(textmod,"protected ");
if(mod&MOD_PRIVATE)strcat(textmod,"private ");
if(mod&MOD_STATIC)strcat(textmod,"static ");
if(mod&MOD_FINAL)strcat(textmod,"final ");
if(mod&MOD_ABSTRACT)strcat(textmod,"abstract ");
if(mod&MOD_NATIVE)strcat(textmod,"native ");
return textmod;
}

void vypisTriedy(int ix){
int i,ixn;char mt[80];
FILE *vyst;
if(triedy[ix].pristup&MOD_NATIVE)return;
strcpy(mt,triedy[ix].menoTr);strcat(mt,".jal");
vyst=fopen(mt,"w");
if(vyst==NULL)xxerror("Nemozno vytvorit subor:",mt);
fprintf(vyst,".source %s\n",src);
fprintf(vyst,".class %s %s\n",vratMod(triedy[ix].pristup),triedy[ix].menoTr);
ixn=triedy[ix].ixntr; fprintf(vyst,".super %s\n",triedy[ixn].javaTr);
for(i=0;i<triedy[ix].pocDatClenov;i++){
	fprintf(vyst,".field %s %s %s\n",vratMod(triedy[ix].DatCleny[i].pristup),
		triedy[ix].DatCleny[i].meno,triedy[ix].DatCleny[i].signatura);
	}
ImplicitnyKonstruktor(ix,vyst);
for(i=0;i<triedy[ix].pocMetod;i++){
	fprintf(vyst,"\n.method %s %s %s%s\n",vratMod(triedy[ix].Metody[i].pristup),
		triedy[ix].Metody[i].meno,
		triedy[ix].Metody[i].signaturaP,triedy[ix].Metody[i].signaturaR);
	if(triedy[ix].Metody[i].kod!=NULL){
		fprintf(vyst,"\t.stack 50\n");
		fprintf(vyst,"\t.locals 3\n");
		/* fprintf(vyst,"\t.locals %d\n",triedy[ix].Metody[i].velkostLP); */
		fprintf(vyst,triedy[ix].Metody[i].kod);
		}
	fprintf(vyst,".endm\n");
	}
fclose(vyst);
}
