%{
	/* atributy vyrazu */
typedef struct {char *sig;char*kod;} ATRV;
%}

	/* definicia prenasanych hodnot */
%union  {
	char* meno;
	char* txt;
	char* sig;
	unsigned int mod;
	int ihod;
	double dhod;
	char* kod;
	ATRV vhod;
	}
	/* definicia term. symbolov a hodnoty nimi prenasane */
%token		BOOLEAN  DOUBLE  INT  LONG  VOID
%token  	CLASS  EXTENDS  CONSTRUCTOR IMPLEMENTS IMPORT 
%token		PUBLIC PRIVATE PROTECTED
%token		STATIC FINAL ABSTRACT NATIVE
%token		NEW THIS SUPER RETURN IF ELSE WHILE
%token <meno> 	ID
%token <txt>	STR_LITERAL
%token <ihod>   TRIEDA INT_LITERAL
%token <dhod>   DBL_LITERAL
%token		NULL_LITERAL
%token		TRUE_LITERAL
%token		FALSE_LITERAL
%token  	LZZAT  PZZAT  LOZAT  POZAT  LHZAT  PHZAT
%token  	CIARKA  BCIARKA  BODKA  ROVNE INC DEC
	/* priradenie priorit a asociativnosti operatorom */
%right        ROVNE
%left		AND OR
%binary	LT LE GT GE EQ NE
%left		PLUS MINUS
%left		KRAT DEL
%right		INC DEC
%right		BODKA

	/* priradenie prenasanych hodnot neterm. symbolom */
%type <ihod>	NadTrieda
%type <sig>	NepParametre  Parametre  TypVoid  TypDat
%type <mod>	ModTriedy  ModClena  Mod1  Mod2
%type <vhod>	Vyraz  Primarny DCPrirad DCPristup NovyObjekt
%type <vhod>	MetVolanie NepArgumenty Argumenty
%type <kod>   Prikaz Prikazy


%{
typedef unsigned int uint;
typedef	struct { uint pristup;
		char *meno;
		char *signatura;
		} dclen;
typedef	struct { uint pristup;
		char *meno;
		char *signaturaP;char *signaturaR;
		int velkostLP;
		char *kod;
		} met;

struct {
	char *menoTr; char *javaTr;char *sigTr;
	char *menoNadTr; int ixntr;
	uint pristup;
	int pocDatClenov;
	dclen* DatCleny;
	int pocMetod;
	met* Metody;
} triedy[20];
int ix_tr=0;
int ix_m=0;

struct { char *meno; char *sig; int index;} LP[20];
int ixlp=0;
int szlp=0;


#define MOD_PUBLIC    0x0001
#define MOD_PRIVATE   0x0002
#define MOD_PROTECTED 0x0004
#define MOD_STATIC    0x0008
#define MOD_FINAL     0x0010
#define MOD_NATIVE    0x0100
#define MOD_ABSTRACT  0x0400

#include <alloc.h>
#include <stdio.h>
#include <string.h>

FILE *vyst;
int ii,i1,i2;
char sigpom[80];
			/* prototypy */
int yyparse(void), yylex(void);
void ulozImp(char *,char *);
void ulozTr(char *,int,uint);
void ulozDC(char *,char *,uint);
void ulozMet(char *,char *,char *,uint);
int testEM(char *m,int ix);
int testEDC(char *m,int ix);
void yyerror(char*),xxerror(char*,char*);
void vypisTriedy(int);
int najdiDC(char *m,int ix,int *ixx);
int najdiM(char *m,char *sg,int ix,int *ixx);
int najdiT(char *sg);
void ulozLP(char *meno,char *sig);
void initLP(int mod);
void ukoncLP(void);
int najdiLP(char *meno);

#include "lexyy.cpp"
%}

%%
Subor		: Importy Trieda
		| Subor  Trieda
		;
Importy		: /* e */
		| Importy  Import
		;
Import	: IMPORT  ID  NATIVE  STR_LITERAL
			{ ulozImp($2,$4);}
		;
Trieda	: CLASS  ModTriedy ID  NadTrieda  ImpRozhrania
			{ ulozTr($3,$4,$2);}
		  LZZAT  Cleny  PZZAT
		;
ModTriedy	:          {$$=0;}
		| PUBLIC   {$$=MOD_PUBLIC;}
		| ABSTRACT {$$=MOD_ABSTRACT;}
		| FINAL	   {$$=MOD_FINAL;}
		;
NadTrieda	: /* e */
			{ $$=0;}
		| EXTENDS  TRIEDA
			{ $$=$2;}
		;
ImpRozhrania	: /* e */
		| ImpRozhrania IMPLEMENTS TRIEDA
		;
Cleny		: /* e */
		| Cleny  DatovyClen
		| Cleny  Metoda
		| Cleny  error
		;
DatovyClen	: ModClena TypDat  ID  BCIARKA
			{ ulozDC($3,$2,$1);}
		;
ModClena	: Mod1 Mod2 	{$$=$1|$2;}
		;
Mod1		: 		{$$=0;}
		| PUBLIC	{$$=MOD_PUBLIC;}
		| PROTECTED	{$$=MOD_PROTECTED;}
		| PRIVATE	{$$=MOD_PRIVATE;}
		;
Mod2		: 		{$$=0;}
		| STATIC	{$$=MOD_STATIC;}
		| ABSTRACT	{$$=MOD_ABSTRACT;}
		| FINAL		{$$=MOD_FINAL;}
		| STATIC FINAL  {$$=MOD_STATIC|MOD_FINAL;}
		;
Metoda	: ModClena TypDat  ID  {initLP($1&MOD_STATIC);} LOZAT  NepParametre  POZAT
			{ ulozMet($3,$6,$2,$1);}
			TeloMet
		| ModClena TypVoid  ID  {initLP($1&MOD_STATIC);} LOZAT  NepParametre  POZAT
			{ ulozMet($3,$6,$2,$1);}
			TeloMet
		| CONSTRUCTOR {initLP(0);} LOZAT NepParametre POZAT
			{ ulozMet("<init>",$4,"V",MOD_PUBLIC);}
			TeloMet
		;
NepParametre: /* e */
			{ $$=(char*)malloc(3);strcpy($$,"()");}
		| Parametre
			{ $$=strcat($1,")");}
		;
Parametre	: TypDat  ID
			{ ulozLP($2,$1);$$=(char*)malloc(256);strcpy($$,"(");strcat($$,$1);}
		| Parametre  CIARKA  TypDat  ID
			{ ulozLP($4,$3);$$=strcat($1,$3);}
		;
TypVoid	: VOID
			{$$="V";}
		;
TypDat	: INT
			{$$="I";}
		| DOUBLE
			{$$="D";}
		| BOOLEAN
			{$$="Z";}
		| TRIEDA
			{ $$=triedy[$1].sigTr;}
		| TRIEDA LHZAT PHZAT
			{ $$=sigpom;sprintf(sigpom,"[%s",triedy[$1].sigTr);}
		;
TeloMet	: BCIARKA
			{ukoncLP();triedy[ix_tr-1].Metody[ix_m].kod=NULL;}
		| LZZAT  Prikazy  PZZAT
			{ukoncLP();triedy[ix_tr-1].Metody[ix_m].kod=$2;}
		;
Prikazy 	: /* e */ {$$=(char*)malloc(6148);$$[0]=0;}
		| Prikazy Prikaz
			{if($2!=NULL){$$=strcat($1,$2);free($2);}
			 else $$=$1;
			}
		| Prikazy error
		;
Prikaz		: TypDat ZozIdent BCIARKA
			{$$=NULL;}
		| Vyraz BCIARKA
			{$$=(char*)malloc(12+strlen($1.kod));
			 if($1.sig[0]=='V')sprintf($$,"%s",$1.kod);
			 if($1.sig[0]=='L')sprintf($$,"%s\tpop\n",$1.kod);
			 if($1.sig[0]=='I')sprintf($$,"%s\tpop\n",$1.kod);
			 if($1.sig[0]=='Z')sprintf($$,"%s\tpop\n",$1.kod);
			 if($1.sig[0]=='D')sprintf($$,"%s\tpop2\n",$1.kod);
			 if($1.sig[0]=='J')sprintf($$,"%s\tpop2\n",$1.kod);
			 free($1.kod);
			}
		| RETURN BCIARKA
			{$$=(char*)malloc(10);sprintf($$,"\treturn\n");}
		| BCIARKA
			{$$=NULL;}
		| RETURN Vyraz BCIARKA
			{$$=NULL;}
		| WHILE LOZAT Vyraz POZAT Prikaz
			{$$=NULL;}
		| IF LOZAT Vyraz POZAT Prikaz ELSE Prikaz
			{$$=NULL;}
		| IF LOZAT Vyraz POZAT Prikaz
			{$$=NULL;}
		| LZZAT Prikazy PZZAT
			{$$=$2;}
		;
ZozIdent	: ID 			{ulozLP($1,$<sig>0);}
		| ZozIdent CIARKA ID	{ulozLP($3,$<sig>0);}
		;
Vyraz		: Primarny		{$$=$1;}
		| Vyraz PLUS Vyraz	{$$.kod=NULL;}
		| Vyraz MINUS Vyraz 	{$$.kod=NULL;}
		| Vyraz KRAT Vyraz	{$$.kod=NULL;}
		| Vyraz DEL Vyraz 	{$$.kod=NULL;}
		| Vyraz LT Vyraz	{$$.kod=NULL;}
		| Vyraz LE Vyraz	{$$.kod=NULL;}
		| Vyraz GT Vyraz	{$$.kod=NULL;}
		| Vyraz GE Vyraz	{$$.kod=NULL;}
		| Vyraz EQ Vyraz	{$$.kod=NULL;}
		| Vyraz NE Vyraz	{$$.kod=NULL;}
		| Vyraz OR Vyraz	{$$.kod=NULL;}
		| Vyraz AND Vyraz	{$$.kod=NULL;}
		;
Primarny	: ID
			{ ii=najdiLP($1);$$.sig=LP[ii].sig;$$.kod=(char*)malloc(20);
			  if($$.sig[0]=='L')sprintf($$.kod,"\taload\t%d\n",LP[ii].index);
			  if($$.sig[0]=='I')sprintf($$.kod,"\tiload\t%d\n",LP[ii].index);
			  if($$.sig[0]=='Z')sprintf($$.kod,"\tiload\t%d\n",LP[ii].index);
			  if($$.sig[0]=='D')sprintf($$.kod,"\tdload\t%d\n",LP[ii].index);
			}
		| ID ROVNE Vyraz
			{ ii=najdiLP($1);
			  $$.sig=LP[ii].sig;
			  $$.kod=(char*)malloc(20+strlen($3.kod));
			  if(strcmp(LP[ii].sig,$3.sig)!=0)yyerror("Nekompatibilne priradenie");
			  if(LP[ii].sig[0]=='L')sprintf($$.kod,"%s\tastore\t%d\n\taload\t%d\n",$3.kod,LP[ii].index,LP[ii].index);
			  if(LP[ii].sig[0]=='I')sprintf($$.kod,"%s\tistore\t%d\n\tiload\t%d\n",$3.kod,LP[ii].index,LP[ii].index);
			  if(LP[ii].sig[0]=='D')sprintf($$.kod,"%s\tdstore\t%d\n\tdload\t%d\n",$3.kod,LP[ii].index,LP[ii].index);
			  if(LP[ii].sig[0]=='Z')sprintf($$.kod,"%s\tistore\t%d\n\tiload\t%d\n",$3.kod,LP[ii].index,LP[ii].index);
			  free($3.kod);
			}
		| DCPrirad		{ $$=$1;}
		| THIS
			{ $$.sig=triedy[ix_tr-1].sigTr;
			  $$.kod=(char*)malloc(20);sprintf($$.kod,"\taload_0\n");
			}
		| NovyObjekt		{ $$=$1;}
		| MetVolanie		{ $$=$1;}
		| DCPristup		{ $$=$1;}
		| NULL_LITERAL
			{
			 $$.sig="A";$$.kod=(char*)malloc(20);
			  sprintf($$.kod,"\taconst_null\n");
			 }
		| INT_LITERAL
			{ $$.sig="I";$$.kod=(char*)malloc(20);
			  sprintf($$.kod,"\tsipush\t%d\n",$1);
			}
		| DBL_LITERAL
			{ $$.sig="D";$$.kod=(char*)malloc(20);
			  sprintf($$.kod,"\tldc2_w\t%lf\n",$1);
			}
		| STR_LITERAL
			{ $$.sig=triedy[1].sigTr;$$.kod=(char*)malloc(10+strlen($1));
			  sprintf($$.kod,"\tldc\t\"%s\"\n",$1);
			}
		| TRUE_LITERAL
			{
			 $$.sig="Z";$$.kod=(char*)malloc(12);
			  sprintf($$.kod,"\ticonst_1\n");
			 }
		| FALSE_LITERAL
			{
			 $$.sig="Z";$$.kod=(char*)malloc(12);
			  sprintf($$.kod,"\ticonst_0\n");
			 }
		| LOZAT  Vyraz  POZAT
			{ $$=$2;}
		| TRIEDA LOZAT Vyraz POZAT
			{
			  $$.sig=triedy[$1].sigTr;$$.kod=$3.kod;
			  if($3.sig[0]=='A');
			  else xxerror("Nemozno konvertovat na TRIEDU: ",$3.sig);
			 }
		| INT LOZAT Vyraz POZAT
			{ $$.sig="I";
			  if($3.sig[0]=='I'){$$.kod=$3.kod;}
			  else if($3.sig[0]=='D'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\td2i\n",$3.kod);free($3.kod);
				}
			  else if($3.sig[0]=='J'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\tl2i\n",$3.kod);free($3.kod);
				}
			  else { xxerror("Nemozno konvertovat na INT: ",$3.sig);
				$$.kod=$3.kod;
				}
			}
		| DOUBLE LOZAT Vyraz POZAT
			{ $$.sig="D";
			  if($3.sig[0]=='D'){$$.kod=$3.kod;}
			  else if($3.sig[0]=='I'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\ti2d\n",$3.kod);free($3.kod);
				}
			  else if($3.sig[0]=='J'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\tl2d\n",$3.kod);free($3.kod);
				}
			  else { xxerror("Nemozno konvertovat na DOUBLE: ",$3.sig);
				$$.kod=$3.kod;
				}
			}
		| LONG LOZAT Vyraz POZAT
			{ $$.sig="J";
			  if($3.sig[0]=='J'){$$.kod=$3.kod;}
			  else if($3.sig[0]=='I'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\ti2l\n",$3.kod);free($3.kod);
				}
			  else if($3.sig[0]=='D'){$$.kod=(char*)malloc(10+strlen($3.kod));
				sprintf($$.kod,"%s\td2l\n",$3.kod);free($3.kod);
				}
			  else { xxerror("Nemozno konvertovat na LONG: ",$3.sig);
				$$.kod=$3.kod;
				}
			}
		;		
NovyObjekt 	: NEW  TRIEDA  LOZAT  NepArgumenty  POZAT
			{
			  if(triedy[$2].pristup&MOD_ABSTRACT)
				xxerror("Nemozno vytvorit instanciu ABSTRACT triedy:",triedy[$2].menoTr);
			  /* existuje konstruktor triedy ? */
			  i2=najdiM("<init>",$4.sig,$2,NULL);
			  $$.sig=triedy[$2].sigTr;
			  $$.kod=(char*)malloc(2048);
			  sprintf($$.kod,"\tnew\t%s\n\tdup\n%s\tinvokespecial\t%s <init> %sV\n",
				triedy[$2].javaTr,$4.kod,triedy[$2].javaTr,$4.sig);
			  free($4.kod);free($4.sig);
			}
		;
MetVolanie	: TRIEDA BODKA ID LOZAT NepArgumenty POZAT
			{i2=najdiM($3,$5.sig,$1,NULL);
			 $$.sig=triedy[$1].Metody[i2].signaturaR;
			 $$.kod=(char*)malloc(100+strlen($5.kod));
			 sprintf($$.kod,"%s\tinvokestatic\t%s %s %s%s\n",$5.kod,
				triedy[$1].javaTr,$3,$5.sig,$$.sig);
			 free($5.sig);free($5.kod);
			 }
		| SUPER LOZAT NepArgumenty POZAT
			{i1=triedy[ix_tr-1].ixntr;
			 i2=najdiM("<init>",$3.sig,i1,NULL);
			 $$.sig=triedy[i1].Metody[i2].signaturaR;
			 $$.kod=(char*)malloc(100+strlen($3.kod));
			 sprintf($$.kod,"\taload_0\n%s\tinvokespecial\t%s <init> %s%s\n",$3.kod,
				triedy[i1].javaTr,$3.sig,$$.sig);
			 free($3.sig);free($3.kod);
			 }
		| Vyraz BODKA ID  LOZAT  NepArgumenty POZAT
			{i1=najdiT($1.sig);i2=najdiM($3,$5.sig,i1,&ii);
			 $$.sig=triedy[ii].Metody[i2].signaturaR;
			 $$.kod=(char*)malloc(100+strlen($1.kod)+strlen($5.kod));
			 sprintf($$.kod,"%s%s\tinvokevirtual\t%s %s %s%s\n",$1.kod,$5.kod,
				triedy[i1].javaTr,$3,$5.sig,$$.sig);
			 free($5.sig);free($5.kod);
			 }
		| ID  LOZAT  NepArgumenty POZAT
			{i1=ix_tr-1;i2=najdiM($1,$3.sig,i1,&ii);
			 $$.sig=triedy[ii].Metody[i2].signaturaR;
			 $$.kod=(char*)malloc(100+strlen($3.kod));
			 if(triedy[ii].Metody[i2].pristup&MOD_STATIC)
				 sprintf($$.kod,"%s\tinvokestatic\t%s %s %s%s\n",$3.kod,
					triedy[i1].javaTr,$1,$3.sig,$$.sig);
			 else 
				 sprintf($$.kod,"\taload_0\n%s\tinvokevirtual\t%s %s %s%s\n",$3.kod,
					triedy[i1].javaTr,$1,$3.sig,$$.sig);
			 free($3.sig);free($3.kod);
			 }
		;
DCPristup	: TRIEDA BODKA ID
			{i2=najdiDC($3,$1,NULL);
			 $$.kod=(char*)malloc(80);
			 $$.sig=triedy[$1].DatCleny[i2].signatura;
			 if(triedy[$1].DatCleny[i2].pristup&MOD_STATIC==0)
				xxerror("Clen nie je staticky",$3);
			 sprintf($$.kod,"\tgetstatic\t%s %s %s\n",triedy[$1].javaTr,$3,$$.sig);
			 }
		| Vyraz BODKA ID
			{i1=najdiT($1.sig);i2=najdiDC($3,i1,&ii);
			 $$.kod=(char*)malloc(80+strlen($1.kod));
			 $$.sig=triedy[ii].DatCleny[i2].signatura;
			 if(triedy[i1].DatCleny[i2].pristup&MOD_STATIC)
				xxerror("Clen nesmie byt staticky",$3);
			 sprintf($$.kod,"%s\tgetfield\t%s %s %s\n",$1.kod,triedy[i1].javaTr,$3,$$.sig);
			 free($1.kod);
			}
		;
DCPrirad	: TRIEDA BODKA ID  ROVNE Vyraz
			{i2=najdiDC($3,$1,NULL);
			 $$.kod=(char*)malloc(160+strlen($5.kod));
			 $$.sig=triedy[$1].DatCleny[i2].signatura;
			 if(strcmp($$.sig,$5.sig)!=0)
				yyerror("Nekompatibilne priradenie");			
			 if(triedy[$1].DatCleny[i2].pristup&MOD_STATIC==0)
				xxerror("Clen nie je staticky",$3);
			 sprintf($$.kod,"%s\tputstatic\t%s %s %s\n\tgetstatic\t%s %s %s\n",
					$5.kod, triedy[$1].javaTr,$3,$$.sig, triedy[$1].javaTr,$3,$$.sig);
			 free($5.kod);
			}
		| Vyraz BODKA ID  ROVNE Vyraz
			{i1=najdiT($1.sig);i2=najdiDC($3,i1,&ii);
			 $$.kod=(char*)malloc(160+2*strlen($1.kod)+strlen($5.kod));
			 $$.sig=triedy[i1].DatCleny[i2].signatura;
			 if(strcmp($$.sig,$5.sig)!=0)
				yyerror("Nekompatibilne priradenie");			
			 if(triedy[i1].DatCleny[i2].pristup&MOD_STATIC)
				xxerror("Clen nesmie byt staticky",$3);
			 sprintf($$.kod,"%s%s\tputfield\t%s %s %s\n%s\tgetfield\t%s %s %s\n",
					$1.kod, $5.kod, triedy[i1].javaTr,$3,$$.sig, $1.kod,triedy[i1].javaTr,$3,$$.sig);
			 free($1.kod);free($5.kod);
			}
		| Vyraz BODKA ID INC 
			{i1=najdiT($1.sig);i2=najdiDC($3,i1,&ii);
			 $$.kod=(char*)malloc(160+3*strlen($1.kod));
			 $$.sig=triedy[i1].DatCleny[i2].signatura;
			 if(strcmp($$.sig,"I")!=0)
				yyerror("Nekompatibilne priradenie");			
			 sprintf($$.kod,"%s\tgetfield\t%s %s %s\n%s%s\tgetfield\t%s %s %s\n\tbipush 1\n\tiadd\n\tputfield\t%s %s %s\n",
					$1.kod, triedy[i1].javaTr,$3,$$.sig, $1.kod, $1.kod, triedy[i1].javaTr,$3,$$.sig, triedy[i1].javaTr,$3,$$.sig);
			 free($1.kod);
			}
		| INC Vyraz BODKA ID
			{$$.kod=NULL;}
		| Vyraz BODKA ID DEC
			{$$.kod=NULL;}
		| DEC Vyraz BODKA ID
			{$$.kod=NULL;}
		;
NepArgumenty    : /* e */
			{ $$.sig=(char*)malloc(4);strcpy($$.sig,"()");
			  $$.kod=(char*)malloc(1);$$.kod[0]=0;
			}
		| Argumenty
			{ $$.sig=strcat($1.sig,")");$$.kod=$1.kod;
			}
		;
Argumenty       : Vyraz
			{ $$.sig=(char*)malloc(256);strcpy($$.sig,"(");strcat($$.sig,$1.sig);
			  $$.kod=(char*)malloc(4096);strcpy($$.kod,$1.kod);
			}
		| Argumenty  CIARKA  Vyraz
			{ $$.sig=strcat($1.sig,$3.sig);$$.kod=strcat($1.kod,$3.kod);}
		;
%%

static int pocetChyb=0;
void yyerror(char *s){
//extern int riadok;
fprintf(stdout,"CHYBA: %s [%s:%d]\n",s,yytext,riadok);
pocetChyb++;
}

void xxerror(char *s1,char *s2){
//extern int riadok;
fprintf(stdout,"CHYBA: %s %s [%d]\n",s1,s2,riadok);
pocetChyb++;
}

static char src[20];

int main(int ac,char *av[]){
extern FILE *yyin;
int i;
if(ac>1){
	yyin=fopen(av[1],"r");strcpy(src,av[1]);
	if(yyin==NULL){yyin=stdin;strcpy(src,"stdin");}
	}
ulozImp("Object","java/lang/Object");
ulozImp("String","java/lang/String");
ulozImp("System","java/lang/System");
(void)yyparse();
fprintf(stderr,"POCET CHYB: %d\n",pocetChyb);
for(i=0;i<ix_tr;i++)vypisTriedy(i);
getchar();
return(0);
}

char* ulozStr(char *s){
return strdup(s);
}

void ulozImp(char *meno,char *jmeno){
FILE *fi;char t[80],t1[80],t2[80],dt[10];int i,pdc,pm;uint pr;
fi=fopen("java.api","r");
if(fi==NULL){xxerror("Nemozno najst archiv","java.api");return;}
fscanf(fi,"%s",t);
while(strcmp(t,".end")!=0){
	if(strcmp(t,".class")!=0 && strcmp(t,".interface")!=0){fscanf(fi,"%s",t);continue;}
	fscanf(fi,"%x %s",&pr,t);if(strcmp(t,jmeno)!=0){fscanf(fi,"%s",t);continue;}
	triedy[ix_tr].pristup=pr|MOD_NATIVE;
	triedy[ix_tr].menoTr=meno;triedy[ix_tr].javaTr=jmeno;
	triedy[ix_tr].sigTr=(char*)malloc(strlen(jmeno)+3);
	sprintf(triedy[ix_tr].sigTr,"L%s;",jmeno);
	triedy[ix_tr].menoNadTr=NULL;triedy[ix_tr].ixntr= -1;
	fscanf(fi,"%s",t);
	if(strcmp(t,".super")==0){ fscanf(fi,"%s",t);
		for(i=0;i<ix_tr;i++)
			if(strcmp(triedy[i].menoTr,t)==0||strcmp(triedy[i].javaTr,t)==0){
				triedy[ix_tr].menoNadTr=triedy[i].menoTr;triedy[ix_tr].ixntr=i;
				}
		if(triedy[ix_tr].ixntr<0){xxerror("Nemozno najst nadtriedu:",t);}
		}
	fscanf(fi,"%d",&pdc);triedy[ix_tr].pocDatClenov=pdc;
	if(pdc>0)triedy[ix_tr].DatCleny=(dclen*)calloc(pdc,sizeof(dclen));
	for(i=0;i<pdc;i++){ fscanf(fi,"%s %x %s %s\n",dt,&pr,t1,t2);
			triedy[ix_tr].DatCleny[i].meno=ulozStr(t1);
			triedy[ix_tr].DatCleny[i].signatura=ulozStr(t2);
			triedy[ix_tr].DatCleny[i].pristup=pr;
			}
	fscanf(fi,"%d",&pm);triedy[ix_tr].pocMetod=pm;
	if(pm>0)triedy[ix_tr].Metody=(met*)calloc(pm,sizeof(met));
	for(i=0;i<pm;i++){ fscanf(fi,"%s %x %s %s %s\n",dt,&pr,t,t1,t2);
			triedy[ix_tr].Metody[i].pristup=pr;
			triedy[ix_tr].Metody[i].meno=ulozStr(t);
			triedy[ix_tr].Metody[i].signaturaP=ulozStr(t1);
			triedy[ix_tr].Metody[i].signaturaR=ulozStr(t2);
			}
	ix_tr++;
	fclose(fi);return;
	}
fclose(fi);
xxerror("Nemozno najst JAVA triedu:",jmeno);
}

void ulozTr(char *meno,int ixNT,uint mod){
int i,j,k;
	triedy[ix_tr].menoTr=meno;triedy[ix_tr].javaTr=meno;
	triedy[ix_tr].sigTr=(char*)malloc(strlen(meno)+3);
	sprintf(triedy[ix_tr].sigTr,"L%s;",meno);
	triedy[ix_tr].ixntr= ixNT;
	if(triedy[ixNT].pristup&MOD_FINAL)xxerror("Nemozno dedit z FINAL triedy",triedy[ixNT].menoTr);
	triedy[ix_tr].menoNadTr=triedy[ixNT].menoTr;
	triedy[ix_tr].pristup=mod;
	triedy[ix_tr].pocDatClenov=0;
	triedy[ix_tr].DatCleny=(dclen*)calloc(20,sizeof(dclen));
	triedy[ix_tr].pocMetod=0;
	triedy[ix_tr].Metody=(met*)calloc(20,sizeof(met));
	ix_tr++;
}

int testEDC(char *m,int ix){
int i;
for(i=0;i<triedy[ix].pocDatClenov;i++)
	if(strcmp(m,triedy[ix].DatCleny[i].meno)==0)return 1;
if(triedy[ix].ixntr<0)return 0;
return testEDC(m,triedy[ix].ixntr);
}

int testEM(char *m,int ix){
int i;
for(i=0;i<triedy[ix].pocMetod;i++)
	if(strcmp(m,triedy[ix].Metody[i].meno)==0)return 1;
if(triedy[ix].ixntr<0)return 0;
return testEM(m,triedy[ix].ixntr);
}

void ulozDC(char *meno,char *sig,uint mod){
int i,poc,ixt;
	ixt=ix_tr-1;
	poc=triedy[ixt].pocDatClenov;
	for(i=0;i<poc;i++)
		if(strcmp(triedy[ixt].DatCleny[i].meno,meno)==0){
			xxerror("Viacnasobna deklaracia datoveho clena:",meno);
			return;
			}
	if(testEM(meno,ixt)){xxerror("Existuje (zdedena) metoda:",meno);return;}
	triedy[ixt].DatCleny[poc].meno=meno;
	triedy[ixt].DatCleny[poc].pristup=mod;
	if(mod&MOD_ABSTRACT)xxerror("Datovy clen nemoze byt abstraktny:",meno);
	triedy[ixt].DatCleny[poc].signatura=sig;
	triedy[ixt].pocDatClenov++;
}


void ulozMet(char *meno,char *sigP,char *sigR,uint mod){
int i,ixt;
char *sig;
	ixt=ix_tr-1;
	ix_m=triedy[ixt].pocMetod;
	for(i=0;i<ix_m;i++)
		if(strcmp(triedy[ixt].Metody[i].meno,meno)==0 &&
			 strcmp(triedy[ixt].Metody[i].signaturaP,sigP)==0){
				xxerror("Viacnasobna deklaracia metody:",meno);
				return;
				}
	if(testEDC(meno,ix_tr)){xxerror("Existuje (zdedeny) datovy clen:",meno);return;}
	triedy[ixt].Metody[ix_m].meno=meno;
	triedy[ixt].Metody[ix_m].pristup=mod;
	triedy[ixt].Metody[ix_m].signaturaP=sigP;
	triedy[ixt].Metody[ix_m].signaturaR=sigR;
	triedy[ixt].Metody[ix_m].kod=NULL;
	triedy[ixt].pocMetod++;
}

int najdiDC(char *m,int ix,int *ixx){
int i;
if(ixx!=NULL)*ixx=ix;
for(i=0;i<triedy[ix].pocDatClenov;i++)
	if(strcmp(m,triedy[ix].DatCleny[i].meno)==0){return i;}
if(ixx==NULL || triedy[ix].ixntr<0){xxerror("Neexistujuci dat.clen:",m);return 0;}
return najdiDC(m,triedy[ix].ixntr,ixx);
}

int najdiM(char *m,char *sg,int ix,int *ixx){
int i;
if(ixx!=NULL)*ixx=ix;
for(i=0;i<triedy[ix].pocMetod;i++){
	if(strcmp(m,triedy[ix].Metody[i].meno)==0&&strcmp(sg,triedy[ix].Metody[i].signaturaP)==0){return i;}
	}
if(ixx==NULL || triedy[ix].ixntr<0){xxerror("Neexistujuca metoda:",m);return 0;}
return najdiM(m,sg,triedy[ix].ixntr,ixx);
}

int najdiT(char *sg){
int i;
for(i=0;i<ix_tr;i++){
	if(strcmp(sg,triedy[i].sigTr)==0)return i;
	}
xxerror("Neexistujuca trieda:",sg);
return 0;
}


void ulozLP(char *meno,char *sig){
LP[ixlp].meno=meno;
LP[ixlp].sig=sig;
LP[ixlp].index=szlp;
szlp++;if(sig[0]=='D')szlp++;
ixlp++;
}

void initLP(int modstatic){
ixlp=0;
if(modstatic) szlp=0;	//staticka metoda - nema implicitne THIS
else szlp=1;  //virtualna metoda - ma implicitne THIS
}

void ukoncLP(void){
triedy[ix_tr-1].Metody[ix_m].velkostLP=szlp;
}

int najdiLP(char *meno){
int i;
for(i=0;i<ixlp;i++){
	if(strcmp(meno,LP[i].meno)==0)return(i);
	}
xxerror("Neexistujuca lokalna premenna:",meno);
return(0);
}

void ImplicitnyKonstruktor(int ix,FILE *vyst){
int i,ixn;
for(i=0;i<triedy[ix].pocMetod;i++)
	if(strcmp("<init>",triedy[ix].Metody[i].meno)==0&&strcmp("()",triedy[ix].Metody[i].signaturaP)==0)return;
//autoamticke doplnenie
ixn=triedy[ix].ixntr;
fprintf(vyst,"\n.method public  <init> ()V\n");
fprintf(vyst,"\t.stack 50\n");
fprintf(vyst,"\t.locals 3\n");
fprintf(vyst,"\taload_0\n");
fprintf(vyst,"\tinvokespecial\t%s <init> ()V\n",triedy[ixn].javaTr);
fprintf(vyst,"\treturn\n");
fprintf(vyst,".endm\n");
}

char *vratMod(uint mod){
static char textmod[80];
textmod[0]='\0';
if(mod&MOD_PUBLIC)strcat(textmod,"public ");
if(mod&MOD_PROTECTED)strcat(textmod,"protected ");
if(mod&MOD_PRIVATE)strcat(textmod,"private ");
if(mod&MOD_STATIC)strcat(textmod,"static ");
if(mod&MOD_FINAL)strcat(textmod,"final ");
if(mod&MOD_ABSTRACT)strcat(textmod,"abstract ");
if(mod&MOD_NATIVE)strcat(textmod,"native ");
return textmod;
}

void vypisTriedy(int ix){
int i,ixn;char mt[80];
FILE *vyst;
if(triedy[ix].pristup&MOD_NATIVE)return;
strcpy(mt,triedy[ix].menoTr);strcat(mt,".jal");
vyst=fopen(mt,"w");
if(vyst==NULL)xxerror("Nemozno vytvorit subor:",mt);
fprintf(vyst,".source %s\n",src);
fprintf(vyst,".class %s %s\n",vratMod(triedy[ix].pristup),triedy[ix].menoTr);
ixn=triedy[ix].ixntr; fprintf(vyst,".super %s\n",triedy[ixn].javaTr);
for(i=0;i<triedy[ix].pocDatClenov;i++){
	fprintf(vyst,".field %s %s %s\n",vratMod(triedy[ix].DatCleny[i].pristup),
		triedy[ix].DatCleny[i].meno,triedy[ix].DatCleny[i].signatura);
	}
ImplicitnyKonstruktor(ix,vyst);
for(i=0;i<triedy[ix].pocMetod;i++){
	fprintf(vyst,"\n.method %s %s %s%s\n",vratMod(triedy[ix].Metody[i].pristup),
		triedy[ix].Metody[i].meno,
		triedy[ix].Metody[i].signaturaP,triedy[ix].Metody[i].signaturaR);
	if(triedy[ix].Metody[i].kod!=NULL){
		fprintf(vyst,"\t.stack 50\n");
		fprintf(vyst,"\t.locals %d\n",triedy[ix].Metody[i].velkostLP);
		fprintf(vyst,triedy[ix].Metody[i].kod);
		}
	fprintf(vyst,".endm\n");
	}
fclose(vyst);
}
