<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:p="http://kpi.fei.tuke.sk/practices"
    xmlns:h='http://www.w3.org/1999/xhtml'
                version="1.0">
    
    <xsl:import href="transform.xsl"/>
          
    <!-- ============================ title ========================= -->          
    <xsl:template name="title">
            Zbierka úloh
    </xsl:template>
    
    <!-- ============================ content ========================= -->
    <xsl:template match="p:module" mode="loop">
        <xsl:param name="moduleNumber"/>
        <!--Nazov cvicenia tam bude len ak je v nom aspon jedna uloha alebo doplnujuca uloha-->
        <xsl:if test="count(p:step/p:task) > 0 or count(p:additional/p:task) > 0">
            <div class="content">
                <xsl:value-of select="$moduleNumber"/>. <xsl:apply-templates select="p:title"/>
            </div>
        </xsl:if>
        
        <xsl:if test="count(.//p:task/p:solution) > 0">
            <div class="subheading">Riešené úlohy:
            </div>
            <xsl:for-each select=".//p:task[count(p:solution) > 0]">
                <!--<xsl:if test="count(./p:solution) > 0">-->
                    <ol>
                        <xsl:apply-templates select="."/>
                    </ol>
                <!--</xsl:if>-->
            </xsl:for-each>
        </xsl:if>
        
        <xsl:if test="count(.//p:task[count(p:solution) = 0]) > 0">
            <div class="subheading">Úlohy:
            </div>
            <xsl:for-each select=".//p:task[count(p:solution) = 0]">
                <!--<xsl:if test="count(./p:solution) = 0">-->
                    <ol>
                        <xsl:apply-templates select="."/>
                    </ol>
                <!--</xsl:if>-->
            </xsl:for-each>
        </xsl:if>
        
<!--        <xsl:if test="count(p:additional/p:task) > 0">
            <div class="subheading">Doplňujúce úlohy:
            </div>
            <ol>
                <xsl:apply-templates select="p:additional/p:task"/>
            </ol>
        </xsl:if>-->
    </xsl:template>
</xsl:stylesheet>
