<?xml version="1.0" encoding="UTF-8" ?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:p="http://kpi.fei.tuke.sk/practices"
    xmlns:h='http://www.w3.org/1999/xhtml'
                version="1.0">
    
    <!--Prepisanie importov za ucelom zmenenia obsahu nasimi sablonami-->
    <xsl:import href="../student.xsl"/>
    <xsl:import href="header_menu.xsl"/>
    
    <!--<xsl:output method="html"/>-->
                    
    <!-- ============================ root element ========================= -->
    <xsl:template match="/">
        <xsl:call-template name="page"/>
    </xsl:template>
    
    <!-- ============================ title ========================= -->
    <!--    Nazov zoznamu/zbierky - prepisat v sablone pre konkretnu zbierku -->
    <xsl:template name="title">
            Zoznam
    </xsl:template>
    
    <!-- ============================ module ========================= -->
    <!--Prechadza vsetky xml v adresari programu a pre kazdy z nich urobi v content-->
    <xsl:template match="p:module">
        <xsl:for-each select="collection('../../../?select=[0-9]*.xml')">
            <xsl:variable name="fileName" select="tokenize(document-uri(.), '/')[last()]"/>
            <xsl:apply-templates select="p:module" mode="loop">
                <xsl:with-param name="moduleNumber" select="tokenize($fileName, '\.')[1]"/>
            </xsl:apply-templates>
        </xsl:for-each>
    </xsl:template>
    
    <!-- ============================ content ========================= -->
    <!--Toto prepisat v sablone pre konkretnu zbierku --> 
    <xsl:template match="p:module" mode="loop">
        <xsl:param name="moduleNumber"/>
        <div class="content">
            <xsl:value-of select="$moduleNumber"/>. <xsl:apply-templates select="p:title"/>
        </div>
    </xsl:template>
    
</xsl:stylesheet>
