<?xml version="1.0" encoding="windows-1250"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:p="http://kpi.fei.tuke.sk/practices">

    <xsl:template name="loop">
        <xsl:param name="actual"/>
        <xsl:for-each select="collection('../../../?select=[0-9]*.xml')">
            <xsl:sort select="tokenize(document-uri(.), '/')[last()]"/>
            <xsl:variable name="fileName" select="tokenize(document-uri(.), '/')[last()]"/>
            <xsl:variable name="moduleNumber" select="tokenize($fileName, '\.')[1]"/>
            
            <div class="vertical-3px"/>
            <a>
                <xsl:attribute name="href">
                    <xsl:value-of select="$moduleNumber"/>.html</xsl:attribute>
                <div>
                    <xsl:attribute name="class">
                        <xsl:call-template name="blue_vs_gray_bg">
                            <xsl:with-param name="moduleNumber" select="$moduleNumber"/>
                            <xsl:with-param name="actual" select="$actual"/>
                        </xsl:call-template> menu-item cube1x1 text-in-cube
                    </xsl:attribute>
                    <xsl:value-of select="$moduleNumber"/>
                </div>
            </a>
        </xsl:for-each>
    </xsl:template>
    
    <xsl:template match="/" name="header_menu">
            
        <xsl:variable name="moduleCount" select="count(collection('../../../?select=[0-9]*.xml'))"/>
        <!--sirka stvorceka menu s trojpixelovou medzerou-->
        <xsl:variable name="cubeWidth">33</xsl:variable> 
        <xsl:variable name="menuWidth" select="$moduleCount * $cubeWidth"/>
        
        <div id="menu" style="float: left; width: 100%; height: 30px;">
            <div class="gray-bg text-in-cube">
                <xsl:attribute name="style">float: left; width: <xsl:value-of select="525-$menuWidth"/>px; height:100%;</xsl:attribute>
                Cvienia:
            </div>
            
            <xsl:analyze-string select="base-uri()"
                                regex=".*([0-9]{{2}}).xml">
                
                <!--actual je cislo aktualneho suboru (cvicenia)-->
                <xsl:matching-substring>
                    <xsl:call-template name="loop">
                        <xsl:with-param name="actual" select="number(regex-group(1))"/>
                    </xsl:call-template>
                </xsl:matching-substring>

                <!--Ak nenajde take aktualne cvicenie v zozname, potom actual bude 0 (t.j. ziadne cvicenie nebude oznacene modrou)-->
                <xsl:non-matching-substring>
                    <xsl:call-template name="loop">
                        <xsl:with-param name="actual" select="number(0)"/>
                    </xsl:call-template>
                </xsl:non-matching-substring>

            </xsl:analyze-string>
            
        </div>
    </xsl:template>
    
    <xsl:template name="blue_vs_gray_bg">
        <xsl:param name="moduleNumber"/>
        <xsl:param name="actual"/>
        <xsl:choose>
            <xsl:when test="$moduleNumber=$actual">blue-bg</xsl:when>
            <xsl:otherwise>gray-bg</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
</xsl:stylesheet>
