<?xml version="1.0" encoding="windows-1250"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
                xmlns:p="http://kpi.fei.tuke.sk/practices">
    
    <xsl:import href="page_header.xsl"/>
    <xsl:import href="page_footer.xsl"/>
    <xsl:import href="content.xsl"/>
    <xsl:import href="custom.xsl"/>
    
    <!-- ============================ root element ========================= -->
    <xsl:template match="/" name="page">
        <xsl:text disable-output-escaping='yes'>&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd"&gt;</xsl:text>
        <html>
            <head>
                <meta http-equiv="Content-Language" content="sk" />
                <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
                <link rel="stylesheet" type="text/css" href="style/lecturer.css" />
                <link rel="stylesheet" type="text/css" href="style/page.css" />
                <link rel="stylesheet" type="text/css" href="style/content.css" />
                <link rel="stylesheet" type="text/css" href="style/custom.css" />
                <link rel="icon" href="style/favicon.ico" />
                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
                <!--<xsl:if test="count(//p:math) > 0">-->
                    <script type="text/javascript" src="https://c328740.ssl.cf1.rackcdn.com/mathjax/latest/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script>
                <!--</xsl:if>-->
                <script type="text/x-mathjax-config">
                    MathJax.Hub.Config({
                        TeX: {
                            equationNumbers: {autoNumber: "AMS"}
                        }
                    });
                </script>
                <script type="text/javascript">
                    additionalFunctionality = false;
                    $(document).ready(function() {
                        $(".objective[id] span.clickable").click(highlightSteps);
                        $("#eu-logo").click(toogleAdditionalFunctionality);
                        $("input:checkbox.objectiveCheckbox").change(objectiveCheckboxChange);
                    });
                    function highlightSteps() {
                        var actual = $(this).parent();
                        var id = actual.attr("id");    
                        if (actual.hasClass('highlight')) {
                            $("li."+id).add(actual).removeClass('highlight');
                        } else {
                            $(".objective[id]").add("li[class*='objId_']").removeClass('highlight');
                            $("li."+id).add(actual).addClass('highlight');
                            $("html, body").animate({ scrollTop: $("li."+id).first().offset().top }, 1000);
                        }
                        
                    }
                    function toogleAdditionalFunctionality() {
                        if (additionalFunctionality) {
                            additionalFunctionality = false;
                            removeAdditionalFunctionality();
                        } else {
                            additionalFunctionality = true;
                            addAdditionalFunctionality();
                        }
                    }
                    function addAdditionalFunctionality() {
                        $('.add-func').addClass('add-func-showed').removeClass('add-func');
                    
                        
                    }
                    
                    function removeAdditionalFunctionality() {
                        $('.add-func-showed').addClass('add-func').removeClass('add-func-showed');
                    }
                    
                    function objectiveCheckboxChange() {
                        var classList = $(this).attr('class').split(/\s+/);
                        var objId;
                        $.each( classList, function(index, name){
                            if (name.substring(0,6) === 'objId_') {
                                objId = name;
                            }
                        });
                    
                        if ($(this).is(':checked')) {
                            $('li.'+objId).slideDown(1000);
                        } else {
                            $('li.'+objId).slideUp(1000);
                        }
                    }
                    
                    

                </script>
                <title><xsl:value-of select="p:module/p:title"/></title>
            </head>
            
            <body>
                <div id="page">
                    <!--header-->
                    <xsl:call-template name="page_header"/>
                    
                    <!--content-->
                    <div id="content">
                        <xsl:apply-templates/>
                    </div>
                    
                    <!--footer-->
                    <xsl:call-template name="page_footer"/>
                </div>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>
